#include <stdio.h>
#include <stdlib.h>

#include <OpenGL/gl.h>
#include <GLUT/glut.h>

extern char *load_png(char *name, int *width, int *height);

GLuint texnum;

static void
display(void)
{
	glClear(GL_COLOR_BUFFER_BIT);
	
	glBindTexture(GL_TEXTURE_2D, texnum);
	glColor3f(1.0, 1.0, 1.0);
	glBegin(GL_QUADS); {
		glTexCoord2f(0.0, 0.0); glVertex2f(0.0, 0.0);
		glTexCoord2f(1.0, 0.0); glVertex2f(1.0, 0.0);
		glTexCoord2f(1.0, 1.0); glVertex2f(1.0, 1.0);
		glTexCoord2f(0.0, 1.0); glVertex2f(0.0, 1.0);
	} glEnd();
	
	glFlush();
}

static GLuint
png_texture(char *filename)
{
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	
	GLuint tex;
	glGenTextures(1, &tex);
	glBindTexture(GL_TEXTURE_2D, tex);
	
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	
	int w, h;
	GLubyte *pixels = (GLubyte *)load_png(filename, &w, &h);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, w, h, 0, GL_RGBA, GL_UNSIGNED_BYTE, pixels);
	free(pixels);
	
	return tex;
}

static void
initGL(void)
{
	glClearColor(0.0, 0.0, 0.0, 0.0);
	
	glEnable(GL_TEXTURE_2D);
	texnum = png_texture("monkey.png");
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(-0.1, 1.1, -0.1, 1.1);
}

int
main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGBA);
	glutInitWindowSize(512, 512);
	glutInitWindowPosition(100, 100);
	glutCreateWindow("PNGTexture");
	initGL();
	
	glutDisplayFunc(display);
	glutMainLoop();
	
	return 0;
}